#declare SkyScaffoldStair_debug = 1;


#if(SkyScaffoldStair_debug)

/********************************************************/
/* Camera & Lights */
/********************************************************/

#declare cx = 5;
#declare cy = 6;
#declare cz = 10;

#declare Cam_location_vec = <cx, cy, cz>;
#declare Cam_look_at_vec = <0, cy/4, 0>;
#declare Zoom = 1;
#declare light_location_vec = <cx, cy, cz>;
#declare light_location_vec = <-1000, 2000, 3000>;


#declare G_debug = 0;
#declare G_debug_L = 10;
#declare G_debug_R = 0.06;

#include "FCcamera.INC"
background { rgb<.45,  .45,  .55> }

/*indicate that debug i set */
#debug  "\n "
#debug  "\n * * * * * * * * * * * * * * "
#debug  "\n "
#debug    " SkyScaffoldStair is set for debug "
#debug  "\n * * * * * * * * * * * * * * "
#debug  "\n "
#debug  "\n "



#end /* if debug */
/******************************************************/
/* Object Definition */

#macro SkyScaffoldStairMac (p_W, p_H, p_T,
           p_x0, p_y0, p_z0,
           p_Txt, p_DoTxt, p_NumPair)


//-----------------------------------------
// Var 


#local m = 2;

#local BlockW = 3*m;
#local BlockH = 2*m;
#local BlockT = 1*m;
#local BlockV = <BlockW, BlockH, BlockT>;

#local Thk = m*.0575;

#local de = Thk*2;



//-----------------------------------------
// Main 


// LOAD ONCE
#include "MeshPntTrn.Inc"

mesh{

#local CountJ = p_NumPair-1;
#local J = 0;
#while ( J <= CountJ )

#local ArrY0 = BlockH*1.4*J;



// BOX PARAM
#local bW = BlockW*1;
#local bH = Thk*.5;
#local bT = Thk*4;

#local Init_Trn = <-BlockW*1.25/2, 0, 0>;

// ANGLE PARAM
#local aX = 0;     
#local aY = 4;     
#local aZ = 0;     

// TRN PARAM
#local Place_Trn = <BlockW*1.3/2, Thk*3+m*.1+ArrY0, 0>;
#include "ROT_TRN.tch"





// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

// BOX PARAM
#local bW = BlockW*1.25;
#local bH = Thk;
#local bT = Thk;

#local Init_Trn = <-BlockW*1.25/2, 0, 0>;

// ANGLE PARAM
#local aX = 0;     
#local aY = 0;     
#local aZ = -21;     

// TRN PARAM
#local Place_Trn = <BlockW*1.1/2, Thk*3+m*.1+ArrY0, BlockT/2>;
#include "ROT_TRN.tch"


// TRN PARAM
#local Place_Trn = <BlockW*1.1/2, Thk*3+m*.1+ArrY0, -BlockT/2*0>;
#include "ROT_TRN.tch"




// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
// 4 vert 

#local bW = Thk;
#local bH = BlockH;
#local bT = Thk;

#local bX0 = BlockW/2;
#local bY0 = ArrY0;
#local bZ0 = BlockT/2;
#include "Mesh.tch"
 
#local bX0 = BlockW/2;
#local bY0 = ArrY0;
#local bZ0 = -BlockT/2;
#include "Mesh.tch"
 
#local bX0 = -BlockW/2;
#local bY0 = ArrY0;
#local bZ0 = BlockT/2;
#include "Mesh.tch"
 
#local bX0 = -BlockW/2;
#local bY0 = ArrY0;
#local bZ0 = -BlockT/2;
#include "Mesh.tch"



// 4 hor btm

#local topy0 = BlockH*.2;

#local bW = BlockW+de*2;
#local bH = Thk;
#local bT = Thk;

#local bX0 = 0;
#local bY0 = topy0+ArrY0;
#local bZ0 = -BlockT/2-Thk;
#include "Mesh.tch"
  
#local bX0 = 0;
#local bY0 = topy0+ArrY0;
#local bZ0 = BlockT/2+Thk;
#include "Mesh.tch"


#local bW = Thk;
#local bH = Thk;
#local bT = BlockT+de*2;

#local bX0 = BlockW/2-Thk;
#local bY0 = topy0-Thk*2+ArrY0;
#local bZ0 = 0;
#include "Mesh.tch"
 
#local bX0 = -BlockW/2+Thk;
#local bY0 = topy0-Thk*2+ArrY0;
#local bZ0 = 0;
#include "Mesh.tch"
 
 
// 4 hor top

#local topy0 = BlockH*.75;

#local bW = BlockW+de*2;
#local bH = Thk;
#local bT = Thk;

#local bX0 = 0;
#local bY0 = topy0+ArrY0;
#local bZ0 = -BlockT/2-Thk;
#include "Mesh.tch"
  
#local bX0 = 0;
#local bY0 = topy0+ArrY0;
#local bZ0 = BlockT/2+Thk;
#include "Mesh.tch"


#local bW = Thk;
#local bH = Thk;
#local bT = BlockT+de*2;

#local bX0 = BlockW/2-Thk;
#local bY0 = topy0+Thk+ArrY0;
#local bZ0 = 0;
#include "Mesh.tch"
 
#local bX0 = -BlockW/2+Thk;
#local bY0 = topy0+Thk+ArrY0;
#local bZ0 = 0;
#include "Mesh.tch"
 
#local J = J + 1;
#end









#local CountJ = p_NumPair-1;
#local J = 0;
#while ( J <= CountJ )

#local ArrY0 = BlockH*1.4*(J+.5);



// BOX PARAM
#local bW = BlockW*1;
#local bH = Thk*.5;
#local bT = Thk*4;

#local Init_Trn = <-BlockW*1.25/2, 0, 0>;

// ANGLE PARAM
#local aX = 0;     
#local aY = 4;     
#local aZ = 0;     

// TRN PARAM
#local Place_Trn = <BlockW*1.3/2, Thk*3+m*.1+ArrY0, 0>;
#include "ROT_TRN.tch"






// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

// BOX PARAM
#local bW = BlockW*1.25;
#local bH = Thk;
#local bT = Thk;

#local Init_Trn = <BlockW*1.25/2, 0, 0>;

// ANGLE PARAM
#local aX = 0;     
#local aY = 0;     
#local aZ = 21;     

// TRN PARAM
#local Place_Trn = <-BlockW*1.2/2, Thk*3+m*.1+ArrY0, -BlockT/2>;
#include "ROT_TRN.tch"


// TRN PARAM
#local Place_Trn = <-BlockW*1.2/2, Thk*3+m*.1+ArrY0, -BlockT/2*0>;
#include "ROT_TRN.tch"




// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
// 4 vert 

#local bW = Thk;
#local bH = BlockH;
#local bT = Thk;

#local bX0 = BlockW/2;
#local bY0 = ArrY0;
#local bZ0 = BlockT/2;
#include "Mesh.tch"
 
#local bX0 = BlockW/2;
#local bY0 = ArrY0;
#local bZ0 = -BlockT/2;
#include "Mesh.tch"
 
#local bX0 = -BlockW/2;
#local bY0 = ArrY0;
#local bZ0 = BlockT/2;
#include "Mesh.tch"
 
#local bX0 = -BlockW/2;
#local bY0 = ArrY0;
#local bZ0 = -BlockT/2;
#include "Mesh.tch"



// 4 hor btm

#local topy0 = BlockH*.2;

#local bW = BlockW+de*2;
#local bH = Thk;
#local bT = Thk;

#local bX0 = 0;
#local bY0 = topy0+ArrY0;
#local bZ0 = -BlockT/2-Thk;
#include "Mesh.tch"
  
#local bX0 = 0;
#local bY0 = topy0+ArrY0;
#local bZ0 = BlockT/2+Thk;
#include "Mesh.tch"


#local bW = Thk;
#local bH = Thk;
#local bT = BlockT+de*2;

#local bX0 = BlockW/2-Thk;
#local bY0 = topy0-Thk*2+ArrY0;
#local bZ0 = 0;
#include "Mesh.tch"
 
#local bX0 = -BlockW/2+Thk;
#local bY0 = topy0-Thk*2+ArrY0;
#local bZ0 = 0;
#include "Mesh.tch"
 
 
// 4 hor top

#local topy0 = BlockH*.75;

#local bW = BlockW+de*2;
#local bH = Thk;
#local bT = Thk;

#local bX0 = 0;
#local bY0 = topy0+ArrY0;
#local bZ0 = -BlockT/2-Thk;
#include "Mesh.tch"
  
#local bX0 = 0;
#local bY0 = topy0+ArrY0;
#local bZ0 = BlockT/2+Thk;
#include "Mesh.tch"


#local bW = Thk;
#local bH = Thk;
#local bT = BlockT+de*2;

#local bX0 = BlockW/2-Thk;
#local bY0 = topy0+Thk+ArrY0;
#local bZ0 = 0;
#include "Mesh.tch"
 
#local bX0 = -BlockW/2+Thk;
#local bY0 = topy0+Thk+ArrY0;
#local bZ0 = 0;
#include "Mesh.tch"
 
#local J = J + 1;
#end












      #if (p_DoTxt) 
           texture{ p_Txt }
      #end

      translate<p_x0, p_y0, p_z0>
 }


#end

/******************************************************/
/* if not used as inc then draw object */
#if(SkyScaffoldStair_debug)

#local l_W = 1;
#local l_H = 2;
#local l_T = 3;

#local l_Txt = texture{ pigment{rgb .71} }
#local l_DoTxt = 1;

#local SkyScaffoldStairObj =
SkyScaffoldStairMac
      (l_W, l_H, l_T,
       0, -3, 0,
       l_Txt, l_DoTxt, 10)

//object{ SkyScaffoldStairObj scale .33  translate<0,0,4> } 


#local Count = 7*4-1;
#local I = 0;
#while ( I <= Count )

object{ SkyScaffoldStairObj scale .09133  translate<0,0,5> rotate y*12.5*I scale 1 } 

#local I = I + 1;
#end

#local bW = 2000;
#local bH = -2;
#local bT = 2000;
box{<-bW/2, 0, -bT/2>, <bW/2, bH, bT/2>
	texture{ pigment {rgb .8 }  finish{ ambient .25 diffuse .75 }  }
    }

#end

/******************************************************/
/*
The Call

//------------------------------------------------------
// Stair Section


   #include "SkyScaffoldStair.Inc"


#local l_W = 1;
#local l_H = 2;
#local l_T = 3;

#local l_Txt = texture{ pigment{red 1} }
#local l_DoTxt = 1;

#local SkyScaffoldStairObj =
SkyScaffoldStairMac
      (l_W, l_H, l_T,
       0, 0, 0,
       l_Txt, l_DoTxt)

object{ SkyScaffoldStairObj } 




*/
/*******************************************************/
